# Dataset of "Test-Driven Review: An Empirical Study"
This appendix material refers to the paper "Test-Driven Review: An Empirical Study" published in the Proceedings of the 41st International Conference on Software Engineering (ICSE 2019)

## Content
This package contains the following directories:

1. `TestDrivenReviewExperimentUI/`: tool we used to run the experiment
2. `raw-logs`: this directory contains all the logs we collected on the experiment with the previous tool
3. `TestDrivenReviewAnalysis/`: tool we used to analyse the logs
6. `extracted-data/`: this directory contains a CSV file with all the participants reviews details extracted from the logs
4. `regression.R`: R script to run the statistical model on the CSV
5. `studied-project/`: an anonymized snapshot of the system the experiment is based on
7. `Patches`: it contains the 2 patches of the experiment. The file contains the version before and after the change. To be displayed in a "git-diff" version, they can be pasted on the website "mergerly".
8. `Interview TDR`: script of the interview

## Reproduce the results
To reproduce the results of the paper, you run the R-script provided in the package.

We commented every meaningful line of the R-script, hence it should be straightforward to reproduce.
