package edu.blinded.authors.tdrExperimentAnalysis;

import java.io.IOException;
import java.util.Collection;

public class ExtractFulltextAnswers {

    public static void main(String[] args) throws Exception {
        try {
            analyzeLogs(AnalyzeExperimentLogs.getFiles());
        } catch (final Exception e) {
            System.out.println();
            e.printStackTrace(System.out);
        }
    }

    private static void analyzeLogs(String... filenames) throws IOException {
        final LogRecords log = LogRecords.load(filenames);
        final Collection<SessionData> sessions = log.getSplitByParticipant();

        System.out.println("Number of sessions: " + sessions.size());

        //print rows
        for (final SessionData s : sessions) {
            System.out.println("== " + s.getShortId());
            printIfNonempty(s, "explanationComparisonUnderstanding");
            printIfNonempty(s, "explanationComparisonComplicated");
            printIfNonempty(s, "furtherRemarks");

            for (final String exception : s.getExceptions()) {
                System.out.println(exception);
            }
        }
    }

    private static void printIfNonempty(SessionData s, String name) {
        final String text = s.getVariable(name, "");
        if (!text.isEmpty()) {
            System.out.println(name + ":");
            System.out.println(text);
            System.out.println();
        }
    }

}
