package edu.blinded.authors.tdrExperimentAnalysis;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

public class Multimap<K, V> {

    private final Map<K, List<V>> map = new LinkedHashMap<>();

    public void put(K key, V value) {
        List<V> list = this.map.get(key);
        if (list == null) {
            list = new ArrayList<>();
            this.map.put(key, list);
        }
        list.add(value);
    }

    public Collection<V> get(K key) {
        final List<V> list = this.map.get(key);
        return list == null ? Collections.emptyList() : list;
    }

    public Collection<Entry<K, List<V>>> getEntries() {
        return this.map.entrySet();
    }

}
