package edu.blinded.authors.tdrExperimentAnalysis;

import static edu.blinded.authors.tdrExperimentAnalysis.SessionData.Defect.putDef;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public enum P1 implements SessionData.Defect {

    // maintainability issues PROD
    PROD_METHOD_DESCRIPTION,
    INITIALIZATION_WRONG_PLACE,
    METHOD_SIGNATURE_CHANGE,

    // maintainability issues test
    SQUARE_GLOBAL_VAR,

    // BUG PROD
    NULL_PLAYER,

    // BUG TEST
    WRONG_SQUARE2;

    @Override
    public String getShortString() {
        return this.getClass().getSimpleName() + "_" + this.ordinal();
    }

    @Override
    public boolean isDelocalized() {
        return true;
    }

    static Map<String, List<SessionData.Defect>> getTrueDefects() {
        final Map<String, List<SessionData.Defect>> ret = new LinkedHashMap<>();
        putDef(ret, "#aR;103;why this check here? Should be initialized somewhere else I think!", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;these lines shouldn't be here, consider to put them in the constructor?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;111;Square1 should be declared as a global variable", P1.SQUARE_GLOBAL_VAR);
        putDef(ret, "#bR;141;should a null player be inserted?", P1.NULL_PLAYER);
        putDef(ret, "#aR;104;Does this field really have to be mutable?", SessionData.FP.FP);
        putDef(ret, "#aR;114;Is p==null a valid condition? It's not clear if the \"players\" can contain null values.", P1.NULL_PLAYER);
        putDef(ret, "#aR;117;p is nullable. Consider null-checking or add @NotNull annotation on the parameter, otherwise NPE is possible here", P1.NULL_PLAYER);
        putDef(ret, "#aR;102;no method description", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;107;why set an instance variable?", SessionData.FP.FP);
        putDef(ret, "#bR;123;are you sure? times(1) or times(2)?", SessionData.FP.FP);
        putDef(ret, "#bR;133;add verify(p1)...", SessionData.FP.FP);
        putDef(ret, "#bR;141;square2 instead of square1", P1.WRONG_SQUARE2);
        putDef(ret, "#aR;102;unnecessary signature change, consider to put it in the constructor", P1.METHOD_SIGNATURE_CHANGE);
        putDef(ret, "#bR;110;consider to put Square definition as a member variable", P1.SQUARE_GLOBAL_VAR);
        putDef(ret, "#aR;115;what if there's no such element in the map? is the argument of occupy() nullable?", P1.NULL_PLAYER);
        putDef(ret, "#aR;103;Quibble: space before {", SessionData.FP.FP);
        putDef(ret, "#aR;108;Without documentation, this is hard to tell, but you might be using a boolean flag `inProgress` instead of what should be a Lock!", SessionData.FP.FP);
        putDef(ret, "#aR;110;Shoudn't it be an exception if you try to add a player twice?  Or at least return a bool indicating whether the player was added?  The main issue is that in this codepath, p.occupy is not called...", SessionData.FP.FP);
        putDef(ret, "#aR;102;Can we use full words for params instead of p/b?", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;107;what if b is null?", P1.NULL_PLAYER);
        putDef(ret, "#aR;102;Method does more than register the player, it also puts him in a starting position and sets up a board.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;Seems like this is beyond the scope of this method", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;108;Mixed responsabilities for the func. Please remove the progress state in a different function", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;110;this could be added as an else case after the first case at the begining of the function", SessionData.FP.FP);
        putDef(ret, "#aR;115;Putting the player to a square should be a separate maybe private function", SessionData.FP.FP);
        putDef(ret, "#aR;107;Separate board assignment from player assignment", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;119;This seems to have nothing to do with registering players, please move to a separate method with clear name.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;140;Shouldn't egistering a null player result in an error? If so: add test and fix code accordingly", P1.NULL_PLAYER);
        putDef(ret, "#bR;153;P3 should occupy sauare 3, no?", SessionData.FP.FP);
        putDef(ret, "#aR;107;Do you really intent to swap out the game board when a new player registers?", SessionData.FP.FP);
        putDef(ret, "#aR;108;Where is this used?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;113;is levelreset correctly?", SessionData.FP.FP);
        putDef(ret, "#bR;137;this crashes", P1.NULL_PLAYER);
        putDef(ret, "#aR;102;Board b parameter doesn't seem to be used in anything related with registering player; vague parameter names", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;105;this should probably be handled in constructor", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;108;implicit change of state, suprising that function 'registerPlayer' changes state and board", P1.INITIALIZATION_WRONG_PLACE );
        putDef(ret, "#aR;117;picking a starting square for a player could be rafactored into another method for readability", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;107;Board probably should be created per-test", SessionData.FP.FP);
        putDef(ret, "#bR;111;why would the starting square be square1?", SessionData.FP.FP);
        putDef(ret, "#bR;141;test will fail with NPE", P1.NULL_PLAYER);
        putDef(ret, "#aR;115;The registerPlayer method should have a single responsability. Now it registers a player and place the player in a square.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;116;There is no check for the sqare index to be inside the array bounds", SessionData.FP.FP);
        putDef(ret, "#aR;102;missing null check for player.", P1.NULL_PLAYER);
        putDef(ret, "#aR;110;Should this if be earlier? board and inProgress where already changed.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;113;level and board should be created/mocked separatelly before each test", P1.SQUARE_GLOBAL_VAR);
        putDef(ret, "#bR;141;what is it actually verifying?", SessionData.FP.FP);
        putDef(ret, "#aR;110;Could be added as else if to statement in line 103", SessionData.FP.FP);
        putDef(ret, "#bR;122;duplicate line", SessionData.FP.FP);
        putDef(ret, "#aR;102;p, b are not clean names it will make the code harder to read", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;103;Shouldn't this be the level responsability to already have the players setup?", P1.INITIALIZATION_WRONG_PLACE );
        putDef(ret, "#aR;107;danger saving a board reference... what will happen when 2nd players gets registered?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;Why is board set every time a player is registered? Is b always the same value? If so it should not be set with registerPlayer. What happens when b is another board?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;Please put the handling of the board in a separate function as it has nothing to do with registering a player", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;104;Use shortcut: new ArrayList<>();", SessionData.FP.FP);
        putDef(ret, "#bR;111;Never registered to the board. FF",SessionData.FP.FP );
        putDef(ret, "#aR;102;can two players register with different boards?",SessionData.FP.FP  );
        putDef(ret, "#aR;104;can this be initialized eagerly in the constructor?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;why do we need to hang on to this reference on this class?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;108;when is this set to other values?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;110;can we use a set or other data structure that models this automatically?", SessionData.FP.FP);
        putDef(ret, "#aR;107;Should this be conditional on the player being a new player?", SessionData.FP.FP);
        putDef(ret, "#aR;102;not related to commit description", P1.METHOD_SIGNATURE_CHANGE);
        putDef(ret, "#aR;107;move down after players.contain check", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;Board argument required?", P1.METHOD_SIGNATURE_CHANGE);
        putDef(ret, "#aR;107;All the players share the same board, shouldn't it be initialized once?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;108;When adding an existing player this will stop the progress of a running game. Is that intentional?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;117;I would expect the square to (also) know if it's occupied by a player. Not (just) the player to know where it is.", SessionData.FP.FP);
        putDef(ret, "#aR;102;p and b are poor names for variables. Further, does registering the player belong on the level itself? That seems odd.", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;104;Normally, it makes sense to handle this in the constructor instead. The lazy instantiation makes little sense here.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;108;Is it possible for a player to be registered after the level or board is in progress? If so, this could have a nasty side effect.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;110;should be above line 107 to avoid side effects.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;110;Tests are best named after the business behavior. A new team member will not understand the intent of the tests without reading the whole file. Think behavior here.", SessionData.FP.FP);
        putDef(ret, "#bR;114;This doesn't capture any of the side effects that happen. Should these be tested?", SessionData.FP.FP);
        putDef(ret, "#bR;118;\"registering a player multiple times will not add the player to the board more than once\" - Junit has something like @TestDescription but something needed here.", SessionData.FP.FP);
        putDef(ret, "#bR;137;I don't understand this test. This is describing the behavior, but is this the intent of what the code should do? This seems like it's testing a bug, or there's some design smell here.", SessionData.FP.FP);
        putDef(ret, "#bR;145;Does this test do anything that the second player test doesn't? What novel behavior is being captured here?", SessionData.FP.FP);
        putDef(ret, "#aR;107;Should have checked nullness for Board b as well", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;110;If p is null, I guess this could throw a runtime exception...", P1.NULL_PLAYER);
        putDef(ret, "#aR;103;This should probably be in the constructor", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;This should probably be in the constructor too. Not sure why this method overrides the current board.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;why initialize board, here?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;the board is dynamic, while startSquares are static. Intended?", SessionData.FP.FP);
        putDef(ret, "#aR;107;Why are we setting the board here?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;this side effect isn't obvious from the method name. We shouldn't add another parameter to do this since it's unrelated to the rest of the method", P1.METHOD_SIGNATURE_CHANGE);
        putDef(ret, "#aR;107;If it is necessary to set this.board in this method, it should probably be done after line 112. That way the board is only set if the player is also registered.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;Setting this.board doesn't make any sense to me. either this should be in the constructor, or this needs to a set of boards if multiple boards are allowed", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;assigning a board instance to this.board inside a registerPlayer method does not make sense. Assigning a board should be done in a different method, the board parameter is only used to assign it here which does not make sense", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;why set this.board = b here? it doesnt have anny effect on the rest of the method, it would be better to remove b from this method and set this.board somewhere else", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;Also this.", SessionData.FP.FP);
        putDef(ret, "#aR;107;Why were these initializations added here?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;What happens if this function is called with different boards?", SessionData.FP.FP);
        putDef(ret, "#aR;107;Why does registering a player cause the board to be overwritten?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;Why do we set the board here? This is pretty unexpected, and outside of the single concern this method should have.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;Where is \"this\" coming from?", SessionData.FP.FP);
        putDef(ret, "#aR;107;Why? Synchronization needed?", SessionData.FP.FP);
        putDef(ret, "#aR;108;Would inProgress ever be true while registering players? Is this line necessary?", SessionData.FP.FP);
        putDef(ret, "#aR;108;What is \"inProgress\" measuring? Because we're in a method I'd think that the word suggests we're currently inProgress doing something.  Probably needs to be more specific.", SessionData.FP.FP);
        putDef(ret, "#aR;108;Should this check whether inProgress is true and prevent players from registering if so?", SessionData.FP.FP);
        putDef(ret, "#aR;108;why was this added? does registering a new player mean this instance is no longer in progress?", SessionData.FP.FP);
        putDef(ret, "#aR;108;What happens if this is called when this is already in progress?", SessionData.FP.FP);
        putDef(ret, "#aR;108;Why is this happening?", SessionData.FP.FP);
        putDef(ret, "#aR;108;does this need to be reset at the end of the method? add a comment regarding this", SessionData.FP.FP);
        putDef(ret, "#aR;103;There is a null check for this.players, but not for p. One test passes a null value for p. This needs to be checked as well.", P1.NULL_PLAYER);
        putDef(ret, "#aR;103;take care about multi threading, lock before instatiate players array", SessionData.FP.FP);
        putDef(ret, "#aR;103;Why might this.players be null? Should really be initialised elsewhere", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;This should be ensured by constructor", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;Should be initialized elsewhere.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;Seems like this should probably be instantiated somewhere else", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;perhaps it's better to always initialize this field in a constructor so the check here is not required?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;Weird place to put intialization. Not urgent, but perhaps extract a method called \"initializePlayers()\"", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;I would put initialization of the player arrary somewhere else (e.g. constructor)", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;Under which circumstances may this.players be null? Is it initialized somewhere else?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;Perform initialization in a constructor or field initializer.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;103;Why no initialize in constructor?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;104;A Set would likely be a more appropriate structure", SessionData.FP.FP);
        putDef(ret, "#aR;104;This line seems better suited in a constructor", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;104;I'd initialize this in the constructor instead unless there's a good reason not to.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;104;I'm assuming thread-safety is not an issue here.", SessionData.FP.FP);
        putDef(ret, "#aR;110;This should probably be an exception because it could be indicative of a bug in the calling code", SessionData.FP.FP);
        putDef(ret, "#aR;110;This should be at the top of the function. I'd also add some logging here or throw something instead of just returning", SessionData.FP.FP);
        putDef(ret, "#aR;110;This should go before we set this.board", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;110;What are the common operations on this.players? If the most common operation is contains(), and you expect there to be many, many players, consider using a Set implementation instead of an ArrayList.", SessionData.FP.FP);
        putDef(ret, "#aR;110;Should this check be earlier?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;110;This suggests that a Set of players would be more appropriate. We'd still need this code then, though.", SessionData.FP.FP);
        putDef(ret, "#aR;110;This check is unnecessary if this.players was null and was thus just initialized on #104", SessionData.FP.FP);
        putDef(ret, "#aR;110;Check parameters before performing logic.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;Is it correct that this.board and this.inProgress have been modified?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;Don't use return, instead above check if players is null, then if players contains p otherwise no need to assign to local variables.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;not too sure about this line", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;This check should be done at the beginning of the function, and as part of an else block to the first if.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;should this method just return if the player is already registered? perhaps an exception would be better to inform the caller that this is an invalid operation? that depends on the context which i don't have now", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;This means that the player is not put on a square in case it already exists. Is that intended?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;113;Spacing on new lines", SessionData.FP.FP);
        putDef(ret, "#aR;115;Square should be passed as parameter, registerPlayer must have only one responsability", SessionData.FP.FP);
        putDef(ret, "#aR;115;There is no need to put this is a variable, you can just pass it to p.occupy on line 117", SessionData.FP.FP);
        putDef(ret, "#aR;115;might run into problems if startSquares is null or does not contain any square", SessionData.FP.FP);
        putDef(ret, "#aR;117;Check for null.", P1.NULL_PLAYER);
        putDef(ret, "#aR;117;Do we first need to check whether another player is on the square?", SessionData.FP.FP);
        putDef(ret, "#aR;117;I have the feeling that these changes should be at least two commits.", P1.METHOD_SIGNATURE_CHANGE); // lots of good willing
        putDef(ret, "#aR;117;Should this make sure the square is unoccupied?", SessionData.FP.FP);
        putDef(ret, "#aR;117;Do we have to worry about cases where there are more players than squares?", SessionData.FP.FP);
        putDef(ret, "#aR;117;What if another player has already occupied this square? Is this allowed?", SessionData.FP.FP);
        putDef(ret, "#aR;117;If p is null, this will fail. The test you wrote for this should fail. Did you run the tests before submitting this?", P1.NULL_PLAYER);
        putDef(ret, "#aR;117;Null check?", P1.NULL_PLAYER);
        putDef(ret, "#aR;119;startSquareIndex should be managed in other place", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;119;Aren't startSquareIndex and startSquares affected when the board changes?", SessionData.FP.FP);
        putDef(ret, "#aR;120;If a square can only contain one player, this will cause bugs if we do not delete the square's previous occupant.", SessionData.FP.FP);
        putDef(ret, "#aR;120;what happens when there are more players than startSquares.size? will multiple players occupy the same square?", SessionData.FP.FP);
        putDef(ret, "#aR;120;I'd like to check how it is assured that startSquares will have at least one element, but I have no access to the initializing code.", SessionData.FP.FP);
        putDef(ret, "#aR;121;Without seeing the whole file I can't say much, but I question the object/data structure setup. Is there a design doc for this?", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;102;please, take car about naming conventions, please change p -> player, and b-> board, really we need board to register player?", P1.METHOD_SIGNATURE_CHANGE);
        putDef(ret, "#aR;102;Change this signature to \"Player player, Board board\"", P1.METHOD_SIGNATURE_CHANGE);
        putDef(ret, "#aR;102;Missing documentation (at least for new Board b)", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;108;Why?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;Will not (re)-place p to start square. Either bug or missing doc.", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;102;There's no guard against null \"p\" or \"b\"", P1.NULL_PLAYER);
        putDef(ret, "#aR;102;This doesn't belong here, consider puting it in the constructor", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;This is a contract change to a public method. This could also use a comment as the side-effects aren't obvious", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;registerPlayer probably shouldn't also register the board. This seems like it could result in an unexpected side effect.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;Meaningless variable name", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;102;a null check for the p parameter is required, you don't want to add nulls to the player list or call occupy on a null reference", P1.NULL_PLAYER);
        putDef(ret, "#aR;102;What is the purpose of taking in Board b? If it is simply to initialie this.board, perhaps this it is better to set the board in a different method like setBoard() or even in the constructor. In this method, you could just asser that board is not none (if the board is needed in this method at all).", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;Why the change in signature?", P1.METHOD_SIGNATURE_CHANGE);
        putDef(ret, "#aR;102;This method now apparently also sets the board. Since there's no direct connection between player and board, I would separete this into a different method.", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;what happens if p or b are null?", P1.NULL_PLAYER);
        putDef(ret, "#aR;102;Write identifiers out in full. Why is a board needed to register a player?", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;102;Add @Nullable if these can be null, rename params to be more descriptive, make final", P1.NULL_PLAYER);
        putDef(ret, "#aR;102;single letter var names = :(", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aL;103;not the right place to create that array", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aL;114;Possible uninitialized list/set", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aL;115;Doesn't do anything (yet), useless code", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;133;Why square2?", P1.WRONG_SQUARE2);
        putDef(ret, "#bR;141;square1 vs square2 in this function?", P1.WRONG_SQUARE2);
        putDef(ret, "#bR;141;shouldn't this be square2?", P1.WRONG_SQUARE2);
        putDef(ret, "#bR;133;You should also check to ensure that p1 exists on the board as well and wasn't replaced by p2", SessionData.FP.FP);
        putDef(ret, "#bR;153;Same comment from line 133", SessionData.FP.FP);
        putDef(ret, "#bR;140;I expect this to crash with NPE", P1.NULL_PLAYER);
        putDef(ret, "#bR;108;This seems like a lot of changes to do in one commit. I prefer to break each test into a commit", SessionData.FP.FP);
        putDef(ret, "#bR;141;Should a null object be able to be registered and occupy the board?", P1.NULL_PLAYER);
        putDef(ret, "#bR;153;Previous tests show that first player registered occupies \"square1\", should the third player be occupying it here?", SessionData.FP.FP);
        putDef(ret, "#bR;127;Consider abstracting over this pattern. E.g. have a `registerNthPlayer(int n)` method that creates and registers n players, instead of having `registerSecondPlayer()`, `registerThirdPlayer()`, `registerFourthPlayer()`, ...", SessionData.FP.FP);
        putDef(ret, "#bR;113;I don't see where the level object is created. Can this be more explicit?", SessionData.FP.FP);
        putDef(ret, "#bR;128;I don't understand the logic of the square mocks. registerPlayer takes care of finding the next square; why would the newly created player occupy the mock square? Wouldn't it always occupy a different instance?", SessionData.FP.FP);
        putDef(ret, "#bR;107;Each test should make its own board", SessionData.FP.FP);
        putDef(ret, "#bR;123;what if p occupies squares 1 and 2?", SessionData.FP.FP);
        putDef(ret, "#bR;133;Does this actually check if the square p2 occupies is the second one?", SessionData.FP.FP);
        putDef(ret, "#bR;140;Shouldn't this make sure it throws an error?", P1.NULL_PLAYER);
        putDef(ret, "#bR;141;square1 isn't defined here", P1.WRONG_SQUARE2);
        putDef(ret, "#bR;145;This seems to not test anything new when compared to the register second player test", SessionData.FP.FP);
        putDef(ret, "#bR;153;Why is p3 on square1?", SessionData.FP.FP);
        putDef(ret, "#bR;154;There is a lot of repetition here; I'm not sure of the standards for test setup in java but feel it could be more concise?", P1.SQUARE_GLOBAL_VAR);
        putDef(ret, "#bR;140;Why is it possible to register a null player? This should probably error", P1.NULL_PLAYER);
        putDef(ret, "#bR;114;verify(p, times(1)).occupy(square1);", SessionData.FP.FP);
        putDef(ret, "#bR;123;times(1) should be times(2)", SessionData.FP.FP);
        putDef(ret, "#bR;147;register the same Player three times instead of registering three different Player objects", SessionData.FP.FP);
        putDef(ret, "#bR;113;level has no prior referent: should be documented at least", SessionData.FP.FP);
        putDef(ret, "#bR;138;why is this square2?", P1.WRONG_SQUARE2);
        putDef(ret, "#bR;141;the times calls seem inconsistent: either document them or refactor to make it make more sense. Why is this used here?", SessionData.FP.FP);
        putDef(ret, "#bR;145;this code should be refactored into its own method, or even running all of these tests in a single method: this line is repeated 5 times", P1.SQUARE_GLOBAL_VAR);
        putDef(ret, "#bR;153;this tests that p3 is registered, not that p1 and p2 are or anything else about the state of the board", SessionData.FP.FP);
        putDef(ret, "#bR;114;I lack knowledge of this testing framework, but do these Square objects have to be added to the Level somewhere?", SessionData.FP.FP);
        putDef(ret, "#bR;153;square1 -> square3? unless the mock object has two squares, in which case this is fine.", SessionData.FP.FP);
        putDef(ret, "#bR;111;These tests aren't properly set up - how does the square end up being one of start squares?", P1.SQUARE_GLOBAL_VAR);
        putDef(ret, "#bR;133;This should also verify the p1 call.", SessionData.FP.FP);
        putDef(ret, "#bR;137;This test will fail.", P1.NULL_PLAYER);
        putDef(ret, "#bR;153;This should also verify the p1 and p2 calls.", SessionData.FP.FP);
        putDef(ret, "#bR;141;in case that the player is null, shouldn't a call to occupy be avoided?", SessionData.FP.FP);
        putDef(ret, "#bR;111;Where does this get set as a startSquare? (same for all following tests)", SessionData.FP.FP);
        putDef(ret, "#bR;132;p1 gets silently removed from the board here, because there is only one square. Whether this is intended or not, checking for this behaviour should be part of a separate test; this test should assert the happy path with enough squares for both players, and assert that each player has their square.", SessionData.FP.FP);
        putDef(ret, "#bR;141;What about the NullPointerException this call should have raised?", P1.NULL_PLAYER);
        putDef(ret, "#bR;110;Given_state_When_operation_Then_expectedResult", SessionData.FP.FP);
        putDef(ret, "#bR;111;Add square to level y/n?", SessionData.FP.FP);
        putDef(ret, "#bR;113;Where is \"level\" coming from?", SessionData.FP.FP);
        putDef(ret, "#bR;119;Same", SessionData.FP.FP);
        putDef(ret, "#bR;128;same", SessionData.FP.FP);
        putDef(ret, "#bR;133;verify p1 as well?", SessionData.FP.FP);
        putDef(ret, "#bR;141;Uhhh, how is this supposed to work?", P1.NULL_PLAYER);
        putDef(ret, "#bR;145;Possibly redundant test?", SessionData.FP.FP);
        putDef(ret, "#bR;127;This test allows player overwriting.", SessionData.FP.FP);
        putDef(ret, "#bR;141;Might depend on the system, but should a Null-player be allowed?", P1.NULL_PLAYER);
        putDef(ret, "#bR;153;Again, overwriting or unexpected behaviour possible.", SessionData.FP.FP);
        putDef(ret, "#bR;106;Overall: Do not mock. Overall. Code does not compile. Won't review", SessionData.FP.FP);
        putDef(ret, "#bR;114;Why? New registered player go to their start position.", SessionData.FP.FP);
        putDef(ret, "#bR;141;square1 undefined.", P1.WRONG_SQUARE2);
        putDef(ret, "#aR;102;makr the parames as final", SessionData.FP.FP);
        putDef(ret, "#aR;103;Put null before this.players", SessionData.FP.FP);
        putDef(ret, "#aR;104;Remove the Player from ArrayList", SessionData.FP.FP);
        putDef(ret, "#aR;117;for better understanding you shoul rename the p to something like player(same for b-> board)", P1.PROD_METHOD_DESCRIPTION);
        putDef(ret, "#aR;104;Should also reset/initialize startSquareIndex", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;107;Should be separate method setBoard(Board b); no relation to player", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;111;Merge with first if, after setting inProgress = false", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#aR;119;Extract separate method", P1.INITIALIZATION_WRONG_PLACE);
        putDef(ret, "#bR;141;Should fail", P1.NULL_PLAYER);
        putDef(ret, "#aR;117;check for null otherwise a NPE might be thrown", P1.NULL_PLAYER);
        putDef(ret, "#aR;120;what happens when this wraps around and another player is registered? may players occupying the same square", SessionData.FP.FP);
        putDef(ret, "#bR;133;also check that player 1 occupies square 1", SessionData.FP.FP);
        putDef(ret, "#bR;141;a null player should be allowed to occupy a square?!", P1.NULL_PLAYER);
        putDef(ret, "#bR;153;verify that all players occupy the right fields", SessionData.FP.FP);
        return ret;
    }
}

//    METHOD_DESCRIPTION,
//
//    INITIALIZATION_WRONG_PLACE,
//
//    METHOD_SIGNATURE_CHANGE,
//
//    NULL_PLAYER,
//
//    SQUARE_GLOBAL_VAR,
//
//    WRONG_SQUARE2;