package edu.blinded.authors.tdrExperimentAnalysis;

import edu.blinded.authors.tdrExperimentAnalysis.SessionData.Defect;

public enum PatchToDiff {

    P1 {
        @Override
        public Defect[] getDefects() {
            return edu.blinded.authors.tdrExperimentAnalysis.P1.values();
        }
        @Override
        public int getProdMaint(){ return 3;}
        @Override
        public int getProdBugs(){ return 1;}
        @Override
        public int getTestMaint(){ return 1;}
        @Override
        public int getTestBugs(){ return 1;}
        @Override
        public Patch toDiff() {
            return Patch.PATCH1;
        }
    },
    P2 {
        @Override
        public Defect[] getDefects() {
            return edu.blinded.authors.tdrExperimentAnalysis.P2.values();
        }
        @Override
        public int getProdMaint(){ return 2;}
        @Override
        public int getProdBugs(){ return 3;}
        @Override
        public int getTestMaint(){ return 2;}
        @Override
        public int getTestBugs(){ return 2;}
        @Override
        public Patch toDiff() {
            return Patch.PATCH2;
        }
    };

    public abstract Defect[] getDefects();
    public abstract int getProdMaint();
    public abstract int getProdBugs();
    public abstract int getTestMaint();
    public abstract int getTestBugs();


    public abstract Patch toDiff();

}

